<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body></body>
</html>

<script>
  class Vehice {
    _brand;
    _yearManufactured;

    constructor(paramBrand = "Brand", paramYear = "2023") {
      this._brand = paramBrand;
      this._yearManufactured = paramYear;
    }

    getBrand() {
      return this._brand;
    }

    getYearManufactured() {
      return this._yearManufactured;
    }

    setBrand(paramBrand) {
      this._brand = paramBrand;
    }

    setYearManufactured(paramYear) {
      this._yearManufactured = paramYear;
    }

    print() {
      return this._brand + ", " + this._yearManufactured;
    }
  }

  var vehice1 = new Vehice("Toyota", 2019);
  console.log(vehice1.print());
  console.log(vehice1 instanceof Vehice);

  class Car extends Vehice {
    _vId;
    _modelName;

    constructor(paramVId, paramModelName) {
      super();
      this._vId = paramVId;
      this._modelName = paramModelName;
    }

    getVId() {
      return this._vId;
    }

    getModelName() {
      return this._modelName;
    }

    setVId(paramVId) {
      this._vId = paramVId;
    }

    setModelName(paramModelName) {
      this._modelName = paramModelName;
    }

    honk() {
      console.log(this._modelName + " honking");
    }
  }

  var car1 = new Car("C1", "Vinfast");
  car1.honk();
  car1.setVId("C11");
  console.log(car1.getVId());
  car1.setModelName("Lexus");
  console.log(car1.getModelName());
  console.log(car1 instanceof Car);
  console.log(car1 instanceof Vehice);
  console.log(car1.print());

  class Motorbike extends Vehice {
    _vId;
    _modelName;

    constructor(paramVId, paramModelName) {
      super();
      this._vId = paramVId;
      this._modelName = paramModelName;
    }

    getVId() {
      return this._vId;
    }

    getModelName() {
      return this._modelName;
    }

    setVId(paramVId) {
      this._vId = paramVId;
    }

    setModelName(paramModelName) {
      this._modelName = paramModelName;
    }

    honk() {
      console.log(this._modelName + " honking");
    }
  }

  var motorbike1 = new Motorbike("M1", "Future");
  console.log(motorbike1.getVId());
  console.log(motorbike1.getModelName());
  motorbike1.honk();
  console.log(motorbike1.print());
  console.log(motorbike1 instanceof Motorbike);
  console.log(motorbike1 instanceof Vehice);
  console.log(motorbike1 instanceof Car);
</script>
